# XCWAV - Piecewise cross-correlate a spectrum against a template in pixel space
#         using MKXCTEMPW and XCSAO, make new cal file id file, and reidentify
# July 21, 2003
# By Doug Mink, SAO Telescope Data Center

procedure xcwav (objects)

file	objects=""	{prompt="Object spectrum file"}
int	objband=0	{prompt="Object band"}
file	objtemp=""	{prompt="Template spectrum file"}
file	sectfile=""	{prompt="List of wavelength limits for xcor segments"}
int	nbin=256	{prompt="Number of points to cross-correlate (rebinned)"}
real	ndev=0		{prompt="Reject past this number of standard deviations"}
real	rmin=2.0	{prompt="Reject segment cross-correlations with R < this"}
bool	intdisp=no	{prompt="Fit dispersion function interactively (y or n)"}
bool	intxcor=no	{prompt="Run xcsao interactively (y or n)"}
bool	debug=no	{prompt="Print debugging information (y or n)"}

begin
	char tchar
	file templist
	file obj1
	file filelist
	string obj, objfile
	int icom, icom1, lcom

	xcwav1.objband = objband
	xcwav1.objtemp = objtemp
	xcwav1.nbin = nbin
	xcwav1.sectfile = sectfile
	xcwav1.intxcor = intxcor
	xcwav1.ndev = ndev
	xcwav1.rmin = rmin
	xcwav1.intdisp = intdisp
	xcwav1.debug = debug

	obj = object
	tchar = substr (obj,1,1)

# Make list of templates based on wavelength regions in file
        templist = mktemp ("xcwav")
        mkxctempw (tempfile,tempsect,templist=templist,mode="wavelength")

# Process single spectrum
	if (tchar != '@') {
	    icom = stridx (obj, ',')
	    if (icom < 1) {
		xcwav1 (obj, templist)
		}

# Process comma-separated list of spectrum files
	    else {
		icom1 = 1
		while (icom > 0) {
		    lcom = icom - icom1 - 1
		    obj1 = substr (obj, icom1, lcom)
		    xcwav1 (obj1)
		    icom1 = icom + 1
		    obj = substr (obj, icom1, 128)
		    icom = stridx (obj, ',')
		    }
		obj1 = substr (obj,1, 128)
		xcwav1 (obj1, templist)
		}
	    }

# Process file listing spectrum files
	else {
	    filelist = substr (obj,2, 128)
	    print ("Reading files from ", filelist)
	    list = filelist
	    while (fscan (list, objfile) != EOF) {
		xcwav1 (objfile, templist)
		}
	    }
end

# Jul 21 2003	New program to call xcwav1
